/* $Id: authdb.h,v 1.4 1999/05/28 18:26:10 kaminsky Exp $ */

/*
 *
 * Copyright (C) 1999 David Mazieres (dm@uun.org)
 * Copyright (C) 1999 Michael Kaminsky (kaminsky@lcs.mit.edu)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 *
 */

#ifndef _AUTHDB_H_
#define _AUTHDB_H_

#include "arpc.h"

struct userfile {
  str path;
  bool write;
  userfile (const str &p, bool w) : path (p), write (w) {}
};

extern vector<userfile> userfiles;
extern ptr<userfile> shareduserfile;

struct authentry {
  str user;
  str pubkey;
  str srpinfo;
  int fileno;
};

bool authlookup (authentry *);
bool authadd (authentry *);
bool authupdate (authentry *, authentry *);
bool authdbinit ();

#ifndef HAVE_GETGROUPLIST
extern "C" int getgrouplist(const char *uname, GROUPLIST_T agroup,
			    GROUPLIST_T *groups, int *grpcnt);
#endif /* !HAVE_GETGROUPLIST */

#endif _AUTHDB_H_
