/* $Id: sfsaid.C,v 1.1 1999/03/24 07:25:31 dm Exp $ */

/*
 *
 * Copyright (C) 1999 David Mazieres (dm@uun.org)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 *
 */

/* Agent ID (aid) is a generalized notion of user-ID which may take
 * sessions into account. */

#include "sfsmisc.h"

const sfs_aid sfsaid_sfs = INT64(0x8000000000000000);
const sfs_aid sfsaid_nobody = INT64(0x8000000000000001);

sfs_aid
aup2aid (const authunix_parms *aup)
{
  if (!aup)
    return sfsaid_nobody;

  u_int32_t uid = aup->aup_uid;
  u_int32_t gid = aup->aup_gid;
  if (uid == implicit_cast<u_int32_t> (sfs_uid))
    return sfsaid_sfs;
  if (gid == implicit_cast<u_int32_t> (sfs_gid))
    return aup->aup_len ? sfsaid_nobody : sfsaid_sfs;
  return aup->aup_uid;
}
