// -*-c++-*-
/* This file was automatically generated by rpcc. */

#include "sfs_prot.h"

#ifdef MAINTAINER

const strbuf &
rpc_print (const strbuf &sb, const sfsstat &obj, int recdepth,
           const char *name, const char *prefix)
{
  char *p;
  switch (obj) {
  case SFS_OK:
    p = "SFS_OK";
    break;
  case SFS_BADLOGIN:
    p = "SFS_BADLOGIN";
    break;
  case SFS_NOSUCHHOST:
    p = "SFS_NOSUCHHOST";
    break;
  case SFS_NOTSUPP:
    p = "SFS_NOTSUPP";
    break;
  case SFS_TEMPERR:
    p = "SFS_TEMPERR";
    break;
  default:
    p = NULL;
    break;
  }
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsstat " << name << " = ";
  };
  if (p)
    sb << p;
  else
    sb << int (obj);
  if (prefix)
    sb << ";\n";
  return sb;
};
void
print_sfsstat (const void *_objp, const strbuf *_sbp, int _recdepth,
               const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsstat *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsstat (const sfsstat *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_msgtype &obj, int recdepth,
           const char *name, const char *prefix)
{
  char *p;
  switch (obj) {
  case SFS_HOSTINFO:
    p = "SFS_HOSTINFO";
    break;
  case SFS_KSC:
    p = "SFS_KSC";
    break;
  case SFS_KCS:
    p = "SFS_KCS";
    break;
  case SFS_SESSINFO:
    p = "SFS_SESSINFO";
    break;
  case SFS_AUTHINFO:
    p = "SFS_AUTHINFO";
    break;
  case SFS_SIGNED_AUTHREQ:
    p = "SFS_SIGNED_AUTHREQ";
    break;
  case SFS_AUTHREGISTER:
    p = "SFS_AUTHREGISTER";
    break;
  case SFS_AUTHUPDATE:
    p = "SFS_AUTHUPDATE";
    break;
  default:
    p = NULL;
    break;
  }
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_msgtype " << name << " = ";
  };
  if (p)
    sb << p;
  else
    sb << int (obj);
  if (prefix)
    sb << ";\n";
  return sb;
};
void
print_sfs_msgtype (const void *_objp, const strbuf *_sbp, int _recdepth,
                   const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_msgtype *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_msgtype (const sfs_msgtype *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_service &obj, int recdepth,
           const char *name, const char *prefix)
{
  char *p;
  switch (obj) {
  case SFS_SFS:
    p = "SFS_SFS";
    break;
  case SFS_AUTHSERV:
    p = "SFS_AUTHSERV";
    break;
  default:
    p = NULL;
    break;
  }
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_service " << name << " = ";
  };
  if (p)
    sb << p;
  else
    sb << int (obj);
  if (prefix)
    sb << ";\n";
  return sb;
};
void
print_sfs_service (const void *_objp, const strbuf *_sbp, int _recdepth,
                   const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_service *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_service (const sfs_service *objp)
{
  rpc_print (warnx, *objp);
}

void
print_sfs_extension (const void *_objp, const strbuf *_sbp, int _recdepth,
                     const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_extension *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_extension (const sfs_extension *objp)
{
  rpc_print (warnx, *objp);
}

void
print_sfs_hostname (const void *_objp, const strbuf *_sbp, int _recdepth,
                    const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_hostname *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_hostname (const sfs_hostname *objp)
{
  rpc_print (warnx, *objp);
}

void
print_sfs_hash (const void *_objp, const strbuf *_sbp, int _recdepth,
                const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_hash *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_hash (const sfs_hash *objp)
{
  rpc_print (warnx, *objp);
}

void
print_sfs_secret (const void *_objp, const strbuf *_sbp, int _recdepth,
                  const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_secret *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_secret (const sfs_secret *objp)
{
  rpc_print (warnx, *objp);
}

void
print_sfs_seqno (const void *_objp, const strbuf *_sbp, int _recdepth,
                 const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_seqno *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_seqno (const sfs_seqno *objp)
{
  rpc_print (warnx, *objp);
}

void
print_sfs_pubkey (const void *_objp, const strbuf *_sbp, int _recdepth,
                  const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_pubkey *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_pubkey (const sfs_pubkey *objp)
{
  rpc_print (warnx, *objp);
}

void
print_sfs_ctext (const void *_objp, const strbuf *_sbp, int _recdepth,
                 const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_ctext *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_ctext (const sfs_ctext *objp)
{
  rpc_print (warnx, *objp);
}

void
print_sfs_sig (const void *_objp, const strbuf *_sbp, int _recdepth,
               const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_sig *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_sig (const sfs_sig *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_hashcharge &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_hashcharge " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.bitcost, recdepth, "bitcost", npref);
  sb << sep;
  rpc_print (sb, obj.target, recdepth, "target", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_hashcharge (const void *_objp, const strbuf *_sbp, int _recdepth,
                      const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_hashcharge *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_hashcharge (const sfs_hashcharge *objp)
{
  rpc_print (warnx, *objp);
}

void
print_sfs_hashpay (const void *_objp, const strbuf *_sbp, int _recdepth,
                   const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_hashpay *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_hashpay (const sfs_hashpay *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_hostinfo &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_hostinfo " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.type, recdepth, "type", npref);
  sb << sep;
  rpc_print (sb, obj.hostname, recdepth, "hostname", npref);
  sb << sep;
  rpc_print (sb, obj.pubkey, recdepth, "pubkey", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_hostinfo (const void *_objp, const strbuf *_sbp, int _recdepth,
                    const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_hostinfo *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_hostinfo (const sfs_hostinfo *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_sesskeydat &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_sesskeydat " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.type, recdepth, "type", npref);
  sb << sep;
  rpc_print (sb, obj.ks, recdepth, "ks", npref);
  sb << sep;
  rpc_print (sb, obj.sshare, recdepth, "sshare", npref);
  sb << sep;
  rpc_print (sb, obj.kc, recdepth, "kc", npref);
  sb << sep;
  rpc_print (sb, obj.cshare, recdepth, "cshare", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_sesskeydat (const void *_objp, const strbuf *_sbp, int _recdepth,
                      const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_sesskeydat *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_sesskeydat (const sfs_sesskeydat *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_sessinfo &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_sessinfo " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.type, recdepth, "type", npref);
  sb << sep;
  rpc_print (sb, obj.ksc, recdepth, "ksc", npref);
  sb << sep;
  rpc_print (sb, obj.kcs, recdepth, "kcs", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_sessinfo (const void *_objp, const strbuf *_sbp, int _recdepth,
                    const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_sessinfo *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_sessinfo (const sfs_sessinfo *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_authinfo &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_authinfo " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.type, recdepth, "type", npref);
  sb << sep;
  rpc_print (sb, obj.service, recdepth, "service", npref);
  sb << sep;
  rpc_print (sb, obj.name, recdepth, "name", npref);
  sb << sep;
  rpc_print (sb, obj.hostid, recdepth, "hostid", npref);
  sb << sep;
  rpc_print (sb, obj.sessid, recdepth, "sessid", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_authinfo (const void *_objp, const strbuf *_sbp, int _recdepth,
                    const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_authinfo *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_authinfo (const sfs_authinfo *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_kmsg &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_kmsg " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.kcs_share, recdepth, "kcs_share", npref);
  sb << sep;
  rpc_print (sb, obj.ksc_share, recdepth, "ksc_share", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_kmsg (const void *_objp, const strbuf *_sbp, int _recdepth,
                const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_kmsg *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_kmsg (const sfs_kmsg *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_signed_authreq &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_signed_authreq " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.type, recdepth, "type", npref);
  sb << sep;
  rpc_print (sb, obj.authid, recdepth, "authid", npref);
  sb << sep;
  rpc_print (sb, obj.seqno, recdepth, "seqno", npref);
  sb << sep;
  rpc_print (sb, obj.usrinfo, recdepth, "usrinfo", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_signed_authreq (const void *_objp, const strbuf *_sbp, int _recdepth,
                          const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_signed_authreq *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_signed_authreq (const sfs_signed_authreq *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_connectarg &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_connectarg " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.release, recdepth, "release", npref);
  sb << sep;
  rpc_print (sb, obj.service, recdepth, "service", npref);
  sb << sep;
  rpc_print (sb, obj.name, recdepth, "name", npref);
  sb << sep;
  rpc_print (sb, obj.hostid, recdepth, "hostid", npref);
  sb << sep;
  rpc_print (sb, obj.extensions, recdepth, "extensions", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_connectarg (const void *_objp, const strbuf *_sbp, int _recdepth,
                      const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_connectarg *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_connectarg (const sfs_connectarg *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_connectok &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_connectok " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.release, recdepth, "release", npref);
  sb << sep;
  rpc_print (sb, obj.host, recdepth, "host", npref);
  sb << sep;
  rpc_print (sb, obj.prog, recdepth, "prog", npref);
  sb << sep;
  rpc_print (sb, obj.vers, recdepth, "vers", npref);
  sb << sep;
  rpc_print (sb, obj.charge, recdepth, "charge", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_connectok (const void *_objp, const strbuf *_sbp, int _recdepth,
                     const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_connectok *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_connectok (const sfs_connectok *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_connectres &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_connectres " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.status, recdepth, "status", npref);
  switch (obj.status) {
  case SFS_OK:
    sb << sep;
    rpc_print (sb, *obj.reply,  recdepth, "reply", npref);
    break;
  default:
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_connectres (const void *_objp, const strbuf *_sbp, int _recdepth,
                      const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_connectres *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_connectres (const sfs_connectres *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_encryptarg &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_encryptarg " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.payment, recdepth, "payment", npref);
  sb << sep;
  rpc_print (sb, obj.kmsg, recdepth, "kmsg", npref);
  sb << sep;
  rpc_print (sb, obj.pubkey, recdepth, "pubkey", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_encryptarg (const void *_objp, const strbuf *_sbp, int _recdepth,
                      const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_encryptarg *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_encryptarg (const sfs_encryptarg *objp)
{
  rpc_print (warnx, *objp);
}

void
print_sfs_encryptres (const void *_objp, const strbuf *_sbp, int _recdepth,
                      const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_encryptres *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_encryptres (const sfs_encryptres *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_nfs3_subfs &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_nfs3_subfs " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.path, recdepth, "path", npref);
  sb << sep;
  rpc_print (sb, obj.fh, recdepth, "fh", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_nfs3_subfs (const void *_objp, const strbuf *_sbp, int _recdepth,
                      const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_nfs3_subfs *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_nfs3_subfs (const sfs_nfs3_subfs *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_nfs3_fsinfo &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_nfs3_fsinfo " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.root, recdepth, "root", npref);
  sb << sep;
  rpc_print (sb, obj.subfs, recdepth, "subfs", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_nfs3_fsinfo (const void *_objp, const strbuf *_sbp, int _recdepth,
                       const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_nfs3_fsinfo *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_nfs3_fsinfo (const sfs_nfs3_fsinfo *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_nfs_fsinfo &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_nfs_fsinfo " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.vers, recdepth, "vers", npref);
  switch (obj.vers) {
  case ex_NFS_V3:
    sb << sep;
    rpc_print (sb, *obj.v3,  recdepth, "v3", npref);
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_nfs_fsinfo (const void *_objp, const strbuf *_sbp, int _recdepth,
                      const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_nfs_fsinfo *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_nfs_fsinfo (const sfs_nfs_fsinfo *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_fsinfo &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_fsinfo " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.prog, recdepth, "prog", npref);
  switch (obj.prog) {
  case ex_NFS_PROGRAM:
    sb << sep;
    rpc_print (sb, *obj.nfs,  recdepth, "nfs", npref);
    break;
  default:
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_fsinfo (const void *_objp, const strbuf *_sbp, int _recdepth,
                  const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_fsinfo *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_fsinfo (const sfs_fsinfo *objp)
{
  rpc_print (warnx, *objp);
}

void
print_sfs_idname (const void *_objp, const strbuf *_sbp, int _recdepth,
                  const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_idname *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_idname (const sfs_idname *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_opt_idname &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_opt_idname " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.present, recdepth, "present", npref);
  switch (obj.present) {
  case true:
    sb << sep;
    rpc_print (sb, *obj.name,  recdepth, "name", npref);
    break;
  case false:
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_opt_idname (const void *_objp, const strbuf *_sbp, int _recdepth,
                      const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_opt_idname *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_opt_idname (const sfs_opt_idname *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_idnums &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_idnums " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.uid, recdepth, "uid", npref);
  sb << sep;
  rpc_print (sb, obj.gid, recdepth, "gid", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_idnums (const void *_objp, const strbuf *_sbp, int _recdepth,
                  const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_idnums *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_idnums (const sfs_idnums *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_idnames &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_idnames " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.uidname, recdepth, "uidname", npref);
  sb << sep;
  rpc_print (sb, obj.gidname, recdepth, "gidname", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_idnames (const void *_objp, const strbuf *_sbp, int _recdepth,
                   const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_idnames *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_idnames (const sfs_idnames *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_authtype &obj, int recdepth,
           const char *name, const char *prefix)
{
  char *p;
  switch (obj) {
  case SFS_NOAUTH:
    p = "SFS_NOAUTH";
    break;
  case SFS_AUTHREQ:
    p = "SFS_AUTHREQ";
    break;
  default:
    p = NULL;
    break;
  }
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_authtype " << name << " = ";
  };
  if (p)
    sb << p;
  else
    sb << int (obj);
  if (prefix)
    sb << ";\n";
  return sb;
};
void
print_sfs_authtype (const void *_objp, const strbuf *_sbp, int _recdepth,
                    const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_authtype *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_authtype (const sfs_authtype *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_authreq &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_authreq " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.usrkey, recdepth, "usrkey", npref);
  sb << sep;
  rpc_print (sb, obj.signed_req, recdepth, "signed_req", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_authreq (const void *_objp, const strbuf *_sbp, int _recdepth,
                   const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_authreq *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_authreq (const sfs_authreq *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_autharg &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_autharg " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.type, recdepth, "type", npref);
  switch (obj.type) {
  case SFS_NOAUTH:
    break;
  case SFS_AUTHREQ:
    sb << sep;
    rpc_print (sb, *obj.req,  recdepth, "req", npref);
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_autharg (const void *_objp, const strbuf *_sbp, int _recdepth,
                   const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_autharg *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_autharg (const sfs_autharg *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_credtype &obj, int recdepth,
           const char *name, const char *prefix)
{
  char *p;
  switch (obj) {
  case SFS_NOCRED:
    p = "SFS_NOCRED";
    break;
  case SFS_UNIXCRED:
    p = "SFS_UNIXCRED";
    break;
  default:
    p = NULL;
    break;
  }
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_credtype " << name << " = ";
  };
  if (p)
    sb << p;
  else
    sb << int (obj);
  if (prefix)
    sb << ";\n";
  return sb;
};
void
print_sfs_credtype (const void *_objp, const strbuf *_sbp, int _recdepth,
                    const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_credtype *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_credtype (const sfs_credtype *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_unixcred &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_unixcred " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.username, recdepth, "username", npref);
  sb << sep;
  rpc_print (sb, obj.homedir, recdepth, "homedir", npref);
  sb << sep;
  rpc_print (sb, obj.shell, recdepth, "shell", npref);
  sb << sep;
  rpc_print (sb, obj.uid, recdepth, "uid", npref);
  sb << sep;
  rpc_print (sb, obj.gid, recdepth, "gid", npref);
  sb << sep;
  rpc_print (sb, obj.groups, recdepth, "groups", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_unixcred (const void *_objp, const strbuf *_sbp, int _recdepth,
                    const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_unixcred *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_unixcred (const sfs_unixcred *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_cred &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_cred " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.type, recdepth, "type", npref);
  switch (obj.type) {
  case SFS_NOCRED:
    break;
  case SFS_UNIXCRED:
    sb << sep;
    rpc_print (sb, *obj.unixcred,  recdepth, "unixcred", npref);
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_cred (const void *_objp, const strbuf *_sbp, int _recdepth,
                const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_cred *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_cred (const sfs_cred *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_loginokres &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_loginokres " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.cred, recdepth, "cred", npref);
  sb << sep;
  rpc_print (sb, obj.authid, recdepth, "authid", npref);
  sb << sep;
  rpc_print (sb, obj.seqno, recdepth, "seqno", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_loginokres (const void *_objp, const strbuf *_sbp, int _recdepth,
                      const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_loginokres *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_loginokres (const sfs_loginokres *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_loginstat &obj, int recdepth,
           const char *name, const char *prefix)
{
  char *p;
  switch (obj) {
  case SFSLOGIN_OK:
    p = "SFSLOGIN_OK";
    break;
  case SFSLOGIN_MORE:
    p = "SFSLOGIN_MORE";
    break;
  case SFSLOGIN_BAD:
    p = "SFSLOGIN_BAD";
    break;
  case SFSLOGIN_ALLBAD:
    p = "SFSLOGIN_ALLBAD";
    break;
  default:
    p = NULL;
    break;
  }
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_loginstat " << name << " = ";
  };
  if (p)
    sb << p;
  else
    sb << int (obj);
  if (prefix)
    sb << ";\n";
  return sb;
};
void
print_sfs_loginstat (const void *_objp, const strbuf *_sbp, int _recdepth,
                     const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_loginstat *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_loginstat (const sfs_loginstat *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_loginres &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_loginres " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.status, recdepth, "status", npref);
  switch (obj.status) {
  case SFSLOGIN_OK:
    sb << sep;
    rpc_print (sb, *obj.resok,  recdepth, "resok", npref);
    break;
  case SFSLOGIN_MORE:
    sb << sep;
    rpc_print (sb, *obj.resmore,  recdepth, "resmore", npref);
    break;
  case SFSLOGIN_BAD:
  case SFSLOGIN_ALLBAD:
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfsauth_loginres (const void *_objp, const strbuf *_sbp, int _recdepth,
                        const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_loginres *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_loginres (const sfsauth_loginres *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_loginres &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_loginres " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.status, recdepth, "status", npref);
  switch (obj.status) {
  case SFSLOGIN_OK:
    sb << sep;
    rpc_print (sb, *obj.authno,  recdepth, "authno", npref);
    break;
  case SFSLOGIN_MORE:
    sb << sep;
    rpc_print (sb, *obj.resmore,  recdepth, "resmore", npref);
    break;
  case SFSLOGIN_BAD:
  case SFSLOGIN_ALLBAD:
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_loginres (const void *_objp, const strbuf *_sbp, int _recdepth,
                    const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_loginres *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_loginres (const sfs_loginres *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_loginarg &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_loginarg " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.seqno, recdepth, "seqno", npref);
  sb << sep;
  rpc_print (sb, obj.certificate, recdepth, "certificate", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_loginarg (const void *_objp, const strbuf *_sbp, int _recdepth,
                    const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_loginarg *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_loginarg (const sfs_loginarg *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_srpstat &obj, int recdepth,
           const char *name, const char *prefix)
{
  char *p;
  switch (obj) {
  case SFSAUTH_SRP_OK:
    p = "SFSAUTH_SRP_OK";
    break;
  case SFSAUTH_SRP_NOTTHERE:
    p = "SFSAUTH_SRP_NOTTHERE";
    break;
  case SFSAUTH_SRP_PHASE0:
    p = "SFSAUTH_SRP_PHASE0";
    break;
  case SFSAUTH_SRP_PHASE1:
    p = "SFSAUTH_SRP_PHASE1";
    break;
  case SFSAUTH_SRP_PHASE2:
    p = "SFSAUTH_SRP_PHASE2";
    break;
  case SFSAUTH_SRP_BADSRPINFO:
    p = "SFSAUTH_SRP_BADSRPINFO";
    break;
  default:
    p = NULL;
    break;
  }
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_srpstat " << name << " = ";
  };
  if (p)
    sb << p;
  else
    sb << int (obj);
  if (prefix)
    sb << ";\n";
  return sb;
};
void
print_sfsauth_srpstat (const void *_objp, const strbuf *_sbp, int _recdepth,
                       const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_srpstat *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_srpstat (const sfsauth_srpstat *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_srpinfo &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_srpinfo " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.prime, recdepth, "prime", npref);
  sb << sep;
  rpc_print (sb, obj.generator, recdepth, "generator", npref);
  sb << sep;
  rpc_print (sb, obj.salt, recdepth, "salt", npref);
  sb << sep;
  rpc_print (sb, obj.verifier, recdepth, "verifier", npref);
  sb << sep;
  rpc_print (sb, obj.seckey, recdepth, "seckey", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfsauth_srpinfo (const void *_objp, const strbuf *_sbp, int _recdepth,
                       const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_srpinfo *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_srpinfo (const sfsauth_srpinfo *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_sesskeydat &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_sesskeydat " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.type, recdepth, "type", npref);
  sb << sep;
  rpc_print (sb, obj.key, recdepth, "key", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfsauth_sesskeydat (const void *_objp, const strbuf *_sbp, int _recdepth,
                          const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_sesskeydat *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_sesskeydat (const sfsauth_sesskeydat *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_srp0arg &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_srp0arg " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.username, recdepth, "username", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfsauth_srp0arg (const void *_objp, const strbuf *_sbp, int _recdepth,
                       const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_srp0arg *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_srp0arg (const sfsauth_srp0arg *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_srp0resok &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_srp0resok " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.prime, recdepth, "prime", npref);
  sb << sep;
  rpc_print (sb, obj.generator, recdepth, "generator", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfsauth_srp0resok (const void *_objp, const strbuf *_sbp, int _recdepth,
                         const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_srp0resok *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_srp0resok (const sfsauth_srp0resok *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_srp0res &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_srp0res " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.status, recdepth, "status", npref);
  switch (obj.status) {
  case SFSAUTH_SRP_OK:
    sb << sep;
    rpc_print (sb, *obj.resok,  recdepth, "resok", npref);
    break;
  default:
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfsauth_srp0res (const void *_objp, const strbuf *_sbp, int _recdepth,
                       const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_srp0res *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_srp0res (const sfsauth_srp0res *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_srp1arg &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_srp1arg " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.A, recdepth, "A", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfsauth_srp1arg (const void *_objp, const strbuf *_sbp, int _recdepth,
                       const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_srp1arg *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_srp1arg (const sfsauth_srp1arg *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_srp1resok &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_srp1resok " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.salt, recdepth, "salt", npref);
  sb << sep;
  rpc_print (sb, obj.B, recdepth, "B", npref);
  sb << sep;
  rpc_print (sb, obj.u, recdepth, "u", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfsauth_srp1resok (const void *_objp, const strbuf *_sbp, int _recdepth,
                         const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_srp1resok *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_srp1resok (const sfsauth_srp1resok *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_srp1res &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_srp1res " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.status, recdepth, "status", npref);
  switch (obj.status) {
  case SFSAUTH_SRP_OK:
    sb << sep;
    rpc_print (sb, *obj.resok,  recdepth, "resok", npref);
    break;
  default:
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfsauth_srp1res (const void *_objp, const strbuf *_sbp, int _recdepth,
                       const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_srp1res *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_srp1res (const sfsauth_srp1res *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_srp2arg &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_srp2arg " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.clntproof, recdepth, "clntproof", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfsauth_srp2arg (const void *_objp, const strbuf *_sbp, int _recdepth,
                       const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_srp2arg *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_srp2arg (const sfsauth_srp2arg *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_srp2resok &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_srp2resok " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.servproof, recdepth, "servproof", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfsauth_srp2resok (const void *_objp, const strbuf *_sbp, int _recdepth,
                         const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_srp2resok *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_srp2resok (const sfsauth_srp2resok *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_srp2res &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_srp2res " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.status, recdepth, "status", npref);
  switch (obj.status) {
  case SFSAUTH_SRP_OK:
    sb << sep;
    rpc_print (sb, *obj.resok,  recdepth, "resok", npref);
    break;
  default:
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfsauth_srp2res (const void *_objp, const strbuf *_sbp, int _recdepth,
                       const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_srp2res *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_srp2res (const sfsauth_srp2res *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_fetchstat &obj, int recdepth,
           const char *name, const char *prefix)
{
  char *p;
  switch (obj) {
  case SFSAUTH_FETCH_OK:
    p = "SFSAUTH_FETCH_OK";
    break;
  case SFSAUTH_FETCH_FAILED:
    p = "SFSAUTH_FETCH_FAILED";
    break;
  default:
    p = NULL;
    break;
  }
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_fetchstat " << name << " = ";
  };
  if (p)
    sb << p;
  else
    sb << int (obj);
  if (prefix)
    sb << ";\n";
  return sb;
};
void
print_sfsauth_fetchstat (const void *_objp, const strbuf *_sbp, int _recdepth,
                         const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_fetchstat *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_fetchstat (const sfsauth_fetchstat *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_fetchresok &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_fetchresok " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.seckey, recdepth, "seckey", npref);
  sb << sep;
  rpc_print (sb, obj.hostid, recdepth, "hostid", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfsauth_fetchresok (const void *_objp, const strbuf *_sbp, int _recdepth,
                          const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_fetchresok *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_fetchresok (const sfsauth_fetchresok *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_fetchres &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_fetchres " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.status, recdepth, "status", npref);
  switch (obj.status) {
  case SFSAUTH_FETCH_OK:
    sb << sep;
    rpc_print (sb, *obj.resok,  recdepth, "resok", npref);
    break;
  default:
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfsauth_fetchres (const void *_objp, const strbuf *_sbp, int _recdepth,
                        const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_fetchres *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_fetchres (const sfsauth_fetchres *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_registerarg &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_registerarg " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.username, recdepth, "username", npref);
  sb << sep;
  rpc_print (sb, obj.password, recdepth, "password", npref);
  sb << sep;
  rpc_print (sb, obj.pubkey, recdepth, "pubkey", npref);
  sb << sep;
  rpc_print (sb, obj.srpinfo, recdepth, "srpinfo", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfsauth_registerarg (const void *_objp, const strbuf *_sbp, int _recdepth,
                           const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_registerarg *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_registerarg (const sfsauth_registerarg *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_registerres &obj, int recdepth,
           const char *name, const char *prefix)
{
  char *p;
  switch (obj) {
  case SFSAUTH_REGISTER_OK:
    p = "SFSAUTH_REGISTER_OK";
    break;
  case SFSAUTH_REGISTER_NOTSOCK:
    p = "SFSAUTH_REGISTER_NOTSOCK";
    break;
  case SFSAUTH_REGISTER_BADUSERNAME:
    p = "SFSAUTH_REGISTER_BADUSERNAME";
    break;
  case SFSAUTH_REGISTER_WRONGUID:
    p = "SFSAUTH_REGISTER_WRONGUID";
    break;
  case SFSAUTH_REGISTER_DENYROOT:
    p = "SFSAUTH_REGISTER_DENYROOT";
    break;
  case SFSAUTH_REGISTER_BADSHELL:
    p = "SFSAUTH_REGISTER_BADSHELL";
    break;
  case SFSAUTH_REGISTER_DENYFILE:
    p = "SFSAUTH_REGISTER_DENYFILE";
    break;
  case SFSAUTH_REGISTER_BADPASSWORD:
    p = "SFSAUTH_REGISTER_BADPASSWORD";
    break;
  case SFSAUTH_REGISTER_USEREXISTS:
    p = "SFSAUTH_REGISTER_USEREXISTS";
    break;
  case SFSAUTH_REGISTER_FAILED:
    p = "SFSAUTH_REGISTER_FAILED";
    break;
  default:
    p = NULL;
    break;
  }
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_registerres " << name << " = ";
  };
  if (p)
    sb << p;
  else
    sb << int (obj);
  if (prefix)
    sb << ";\n";
  return sb;
};
void
print_sfsauth_registerres (const void *_objp, const strbuf *_sbp, int _recdepth,
                           const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_registerres *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_registerres (const sfsauth_registerres *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_updatereq &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_updatereq " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.type, recdepth, "type", npref);
  sb << sep;
  rpc_print (sb, obj.authid, recdepth, "authid", npref);
  sb << sep;
  rpc_print (sb, obj.oldkey, recdepth, "oldkey", npref);
  sb << sep;
  rpc_print (sb, obj.newkey, recdepth, "newkey", npref);
  sb << sep;
  rpc_print (sb, obj.srpinfo, recdepth, "srpinfo", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfsauth_updatereq (const void *_objp, const strbuf *_sbp, int _recdepth,
                         const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_updatereq *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_updatereq (const sfsauth_updatereq *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_updatearg &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_updatearg " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.updatereq, recdepth, "updatereq", npref);
  sb << sep;
  rpc_print (sb, obj.signature, recdepth, "signature", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfsauth_updatearg (const void *_objp, const strbuf *_sbp, int _recdepth,
                         const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_updatearg *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_updatearg (const sfsauth_updatearg *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_updateres &obj, int recdepth,
           const char *name, const char *prefix)
{
  char *p;
  switch (obj) {
  case SFSAUTH_UPDATE_OK:
    p = "SFSAUTH_UPDATE_OK";
    break;
  case SFSAUTH_UPDATE_BADSIGNATURE:
    p = "SFSAUTH_UPDATE_BADSIGNATURE";
    break;
  case SFSAUTH_UPDATE_PROTOERR:
    p = "SFSAUTH_UPDATE_PROTOERR";
    break;
  case SFSAUTH_UPDATE_NOTTHERE:
    p = "SFSAUTH_UPDATE_NOTTHERE";
    break;
  case SFSAUTH_UPDATE_BADAUTHID:
    p = "SFSAUTH_UPDATE_BADAUTHID";
    break;
  case SFSAUTH_UPDATE_DENYFILE:
    p = "SFSAUTH_UPDATE_DENYFILE";
    break;
  case SFSAUTH_UPDATE_FAILED:
    p = "SFSAUTH_UPDATE_FAILED";
    break;
  default:
    p = NULL;
    break;
  }
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_updateres " << name << " = ";
  };
  if (p)
    sb << p;
  else
    sb << int (obj);
  if (prefix)
    sb << ";\n";
  return sb;
};
void
print_sfsauth_updateres (const void *_objp, const strbuf *_sbp, int _recdepth,
                         const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_updateres *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_updateres (const sfsauth_updateres *objp)
{
  rpc_print (warnx, *objp);
}

#endif /* MAINTAINER*/
void *
sfsstat_alloc ()
{
  return New sfsstat;
}
bool_t
xdr_sfsstat (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsstat *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsstat *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_msgtype_alloc ()
{
  return New sfs_msgtype;
}
bool_t
xdr_sfs_msgtype (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_msgtype *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_msgtype *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_service_alloc ()
{
  return New sfs_service;
}
bool_t
xdr_sfs_service (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_service *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_service *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_extension_alloc ()
{
  return New sfs_extension;
}
bool_t
xdr_sfs_extension (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_extension *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_extension *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_hostname_alloc ()
{
  return New sfs_hostname;
}
bool_t
xdr_sfs_hostname (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_hostname *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_hostname *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_hash_alloc ()
{
  return New sfs_hash;
}
bool_t
xdr_sfs_hash (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_hash *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_hash *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_secret_alloc ()
{
  return New sfs_secret;
}
bool_t
xdr_sfs_secret (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_secret *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_secret *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_seqno_alloc ()
{
  return New sfs_seqno;
}
bool_t
xdr_sfs_seqno (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_seqno *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_seqno *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_pubkey_alloc ()
{
  return New sfs_pubkey;
}
bool_t
xdr_sfs_pubkey (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_pubkey *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_pubkey *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_ctext_alloc ()
{
  return New sfs_ctext;
}
bool_t
xdr_sfs_ctext (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_ctext *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_ctext *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_sig_alloc ()
{
  return New sfs_sig;
}
bool_t
xdr_sfs_sig (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_sig *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_sig *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_hashcharge_alloc ()
{
  return New sfs_hashcharge;
}
bool_t
xdr_sfs_hashcharge (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_hashcharge *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_hashcharge *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_hashpay_alloc ()
{
  return New sfs_hashpay;
}
bool_t
xdr_sfs_hashpay (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_hashpay *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_hashpay *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_hostinfo_alloc ()
{
  return New sfs_hostinfo;
}
bool_t
xdr_sfs_hostinfo (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_hostinfo *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_hostinfo *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_sesskeydat_alloc ()
{
  return New sfs_sesskeydat;
}
bool_t
xdr_sfs_sesskeydat (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_sesskeydat *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_sesskeydat *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_sessinfo_alloc ()
{
  return New sfs_sessinfo;
}
bool_t
xdr_sfs_sessinfo (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_sessinfo *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_sessinfo *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_authinfo_alloc ()
{
  return New sfs_authinfo;
}
bool_t
xdr_sfs_authinfo (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_authinfo *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_authinfo *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_kmsg_alloc ()
{
  return New sfs_kmsg;
}
bool_t
xdr_sfs_kmsg (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_kmsg *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_kmsg *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_signed_authreq_alloc ()
{
  return New sfs_signed_authreq;
}
bool_t
xdr_sfs_signed_authreq (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_signed_authreq *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_signed_authreq *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_connectarg_alloc ()
{
  return New sfs_connectarg;
}
bool_t
xdr_sfs_connectarg (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_connectarg *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_connectarg *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_connectok_alloc ()
{
  return New sfs_connectok;
}
bool_t
xdr_sfs_connectok (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_connectok *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_connectok *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_connectres_alloc ()
{
  return New sfs_connectres;
}
bool_t
xdr_sfs_connectres (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_connectres *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_connectres *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_encryptarg_alloc ()
{
  return New sfs_encryptarg;
}
bool_t
xdr_sfs_encryptarg (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_encryptarg *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_encryptarg *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_encryptres_alloc ()
{
  return New sfs_encryptres;
}
bool_t
xdr_sfs_encryptres (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_encryptres *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_encryptres *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_nfs3_subfs_alloc ()
{
  return New sfs_nfs3_subfs;
}
bool_t
xdr_sfs_nfs3_subfs (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_nfs3_subfs *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_nfs3_subfs *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_nfs3_fsinfo_alloc ()
{
  return New sfs_nfs3_fsinfo;
}
bool_t
xdr_sfs_nfs3_fsinfo (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_nfs3_fsinfo *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_nfs3_fsinfo *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_nfs_fsinfo_alloc ()
{
  return New sfs_nfs_fsinfo;
}
bool_t
xdr_sfs_nfs_fsinfo (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_nfs_fsinfo *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_nfs_fsinfo *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_fsinfo_alloc ()
{
  return New sfs_fsinfo;
}
bool_t
xdr_sfs_fsinfo (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_fsinfo *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_fsinfo *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_idname_alloc ()
{
  return New sfs_idname;
}
bool_t
xdr_sfs_idname (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_idname *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_idname *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_opt_idname_alloc ()
{
  return New sfs_opt_idname;
}
bool_t
xdr_sfs_opt_idname (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_opt_idname *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_opt_idname *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_idnums_alloc ()
{
  return New sfs_idnums;
}
bool_t
xdr_sfs_idnums (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_idnums *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_idnums *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_idnames_alloc ()
{
  return New sfs_idnames;
}
bool_t
xdr_sfs_idnames (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_idnames *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_idnames *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_authtype_alloc ()
{
  return New sfs_authtype;
}
bool_t
xdr_sfs_authtype (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_authtype *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_authtype *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_authreq_alloc ()
{
  return New sfs_authreq;
}
bool_t
xdr_sfs_authreq (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_authreq *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_authreq *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_autharg_alloc ()
{
  return New sfs_autharg;
}
bool_t
xdr_sfs_autharg (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_autharg *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_autharg *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_credtype_alloc ()
{
  return New sfs_credtype;
}
bool_t
xdr_sfs_credtype (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_credtype *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_credtype *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_unixcred_alloc ()
{
  return New sfs_unixcred;
}
bool_t
xdr_sfs_unixcred (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_unixcred *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_unixcred *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_cred_alloc ()
{
  return New sfs_cred;
}
bool_t
xdr_sfs_cred (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_cred *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_cred *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_loginokres_alloc ()
{
  return New sfs_loginokres;
}
bool_t
xdr_sfs_loginokres (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_loginokres *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_loginokres *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_loginstat_alloc ()
{
  return New sfs_loginstat;
}
bool_t
xdr_sfs_loginstat (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_loginstat *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_loginstat *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_loginres_alloc ()
{
  return New sfsauth_loginres;
}
bool_t
xdr_sfsauth_loginres (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_loginres *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_loginres *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_loginres_alloc ()
{
  return New sfs_loginres;
}
bool_t
xdr_sfs_loginres (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_loginres *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_loginres *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_loginarg_alloc ()
{
  return New sfs_loginarg;
}
bool_t
xdr_sfs_loginarg (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_loginarg *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_loginarg *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_srpstat_alloc ()
{
  return New sfsauth_srpstat;
}
bool_t
xdr_sfsauth_srpstat (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_srpstat *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_srpstat *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_srpinfo_alloc ()
{
  return New sfsauth_srpinfo;
}
bool_t
xdr_sfsauth_srpinfo (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_srpinfo *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_srpinfo *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_sesskeydat_alloc ()
{
  return New sfsauth_sesskeydat;
}
bool_t
xdr_sfsauth_sesskeydat (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_sesskeydat *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_sesskeydat *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_srp0arg_alloc ()
{
  return New sfsauth_srp0arg;
}
bool_t
xdr_sfsauth_srp0arg (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_srp0arg *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_srp0arg *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_srp0resok_alloc ()
{
  return New sfsauth_srp0resok;
}
bool_t
xdr_sfsauth_srp0resok (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_srp0resok *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_srp0resok *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_srp0res_alloc ()
{
  return New sfsauth_srp0res;
}
bool_t
xdr_sfsauth_srp0res (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_srp0res *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_srp0res *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_srp1arg_alloc ()
{
  return New sfsauth_srp1arg;
}
bool_t
xdr_sfsauth_srp1arg (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_srp1arg *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_srp1arg *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_srp1resok_alloc ()
{
  return New sfsauth_srp1resok;
}
bool_t
xdr_sfsauth_srp1resok (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_srp1resok *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_srp1resok *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_srp1res_alloc ()
{
  return New sfsauth_srp1res;
}
bool_t
xdr_sfsauth_srp1res (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_srp1res *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_srp1res *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_srp2arg_alloc ()
{
  return New sfsauth_srp2arg;
}
bool_t
xdr_sfsauth_srp2arg (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_srp2arg *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_srp2arg *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_srp2resok_alloc ()
{
  return New sfsauth_srp2resok;
}
bool_t
xdr_sfsauth_srp2resok (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_srp2resok *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_srp2resok *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_srp2res_alloc ()
{
  return New sfsauth_srp2res;
}
bool_t
xdr_sfsauth_srp2res (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_srp2res *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_srp2res *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_fetchstat_alloc ()
{
  return New sfsauth_fetchstat;
}
bool_t
xdr_sfsauth_fetchstat (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_fetchstat *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_fetchstat *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_fetchresok_alloc ()
{
  return New sfsauth_fetchresok;
}
bool_t
xdr_sfsauth_fetchresok (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_fetchresok *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_fetchresok *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_fetchres_alloc ()
{
  return New sfsauth_fetchres;
}
bool_t
xdr_sfsauth_fetchres (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_fetchres *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_fetchres *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_registerarg_alloc ()
{
  return New sfsauth_registerarg;
}
bool_t
xdr_sfsauth_registerarg (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_registerarg *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_registerarg *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_registerres_alloc ()
{
  return New sfsauth_registerres;
}
bool_t
xdr_sfsauth_registerres (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_registerres *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_registerres *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_updatereq_alloc ()
{
  return New sfsauth_updatereq;
}
bool_t
xdr_sfsauth_updatereq (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_updatereq *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_updatereq *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_updatearg_alloc ()
{
  return New sfsauth_updatearg;
}
bool_t
xdr_sfsauth_updatearg (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_updatearg *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_updatearg *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_updateres_alloc ()
{
  return New sfsauth_updateres;
}
bool_t
xdr_sfsauth_updateres (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_updateres *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_updateres *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

static const rpcgen_table sfs_program_1_tbl[] = {
  SFS_PROGRAM_1_APPLY (XDRTBL_DECL)
};
const rpc_program sfs_program_1 = {
  SFS_PROGRAM, SFS_VERSION, sfs_program_1_tbl,
  sizeof (sfs_program_1_tbl) / sizeof (sfs_program_1_tbl[0]),
  "sfs_program_1"
};

static const rpcgen_table sfscb_program_1_tbl[] = {
  SFSCB_PROGRAM_1_APPLY (XDRTBL_DECL)
};
const rpc_program sfscb_program_1 = {
  SFSCB_PROGRAM, SFSCB_VERSION, sfscb_program_1_tbl,
  sizeof (sfscb_program_1_tbl) / sizeof (sfscb_program_1_tbl[0]),
  "sfscb_program_1"
};

static const rpcgen_table sfsauth_program_1_tbl[] = {
  SFSAUTH_PROGRAM_1_APPLY (XDRTBL_DECL)
};
const rpc_program sfsauth_program_1 = {
  SFSAUTH_PROGRAM, SFSAUTH_VERSION, sfsauth_program_1_tbl,
  sizeof (sfsauth_program_1_tbl) / sizeof (sfsauth_program_1_tbl[0]),
  "sfsauth_program_1"
};


